Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2696)
@@ -1700,6 +3596,4 @@
        CALL exchange_horiz( rad_sw_cs_hr, nbgp )
 
-       CALL exchange_horiz_2d( rad_net )
-       CALL exchange_horiz_2d( rad_lw_out_change_0 )
 #endif
 
@@ -1765,87 +3659,105 @@
 !> Briegleb et al. (1986)
 !------------------------------------------------------------------------------!
-    SUBROUTINE calc_albedo
+    SUBROUTINE calc_albedo( surf )
 
         IMPLICIT NONE
 
-        IF ( sun_up )  THEN
-!
-!--        Ocean
-           IF ( albedo_type == 1 )  THEN
-              rrtm_aldir(0,:,:) = 0.026_wp / ( zenith(0)**1.7_wp + 0.065_wp )  &
+        INTEGER(iwp)    ::  m    !< running index surface elements
+
+        TYPE(surf_type) ::  surf !< treated surfaces
+
+        IF ( sun_up  .AND.  .NOT. average_radiation)  THEN
+
+           DO  m = 1, surf%ns
+!
+!--           Ocean
+              IF ( surf%albedo_type(0,m) == 1 )  THEN
+                 surf%rrtm_aldir(m) = 0.026_wp /                               &
+                                             ( zenith(0)**1.7_wp + 0.065_wp )  &
                                   + 0.15_wp * ( zenith(0) - 0.1_wp )           &
                                             * ( zenith(0) - 0.5_wp )           &
                                             * ( zenith(0) - 1.0_wp )
-              rrtm_asdir(0,:,:) = rrtm_aldir(0,:,:)
-!
-!--        Snow
-           ELSEIF ( albedo_type == 16 )  THEN
-              IF ( zenith(0) < 0.5_wp )  THEN
-                 rrtm_aldir(0,:,:) = 0.5_wp * (1.0_wp - aldif)                 &
+                 surf%rrtm_asdir(m) = surf%rrtm_aldir(m)
+!
+!--           Snow
+              ELSEIF ( surf%albedo_type(0,m) == 16 )  THEN
+                 IF ( zenith(0) < 0.5_wp )  THEN
+                    surf%rrtm_aldir(m) = 0.5_wp * (1.0_wp - surf%aldif(m))     &
                                      * ( 3.0_wp / (1.0_wp + 4.0_wp             &
                                      * zenith(0))) - 1.0_wp
-                 rrtm_asdir(0,:,:) = 0.5_wp * (1.0_wp - asdif)                 &
+                    surf%rrtm_asdir(m) = 0.5_wp * (1.0_wp - surf%asdif(m))     &
                                      * ( 3.0_wp / (1.0_wp + 4.0_wp             &
                                      * zenith(0))) - 1.0_wp
 
-                 rrtm_aldir(0,:,:) = MIN(0.98_wp, rrtm_aldir(0,:,:))
-                 rrtm_asdir(0,:,:) = MIN(0.98_wp, rrtm_asdir(0,:,:))
+                    surf%rrtm_aldir(m) = MIN(0.98_wp, surf%rrtm_aldir(m))
+                    surf%rrtm_asdir(m) = MIN(0.98_wp, surf%rrtm_asdir(m))
+                 ELSE
+                    surf%rrtm_aldir(m) = surf%aldif(m)
+                    surf%rrtm_asdir(m) = surf%asdif(m)
+                 ENDIF
+!
+!--           Sea ice
+              ELSEIF ( surf%albedo_type(0,m) == 15 )  THEN
+                 surf%rrtm_aldir(m) = surf%aldif(m)
+                 surf%rrtm_asdir(m) = surf%asdif(m)
+
+!
+!--           Asphalt
+              ELSEIF ( surf%albedo_type(0,m) == 17 )  THEN
+                 surf%rrtm_aldir(m) = surf%aldif(m)
+                 surf%rrtm_asdir(m) = surf%asdif(m)
+
+
+!
+!--           Bare soil
+              ELSEIF ( surf%albedo_type(0,m) == 18 )  THEN
+                 surf%rrtm_aldir(m) = surf%aldif(m)
+                 surf%rrtm_asdir(m) = surf%asdif(m)
+
+!
+!--           Land surfaces
               ELSE
-                 rrtm_aldir(0,:,:) = aldif
-                 rrtm_asdir(0,:,:) = asdif
+                 SELECT CASE ( surf%albedo_type(0,m) )
+
+!
+!--                 Surface types with strong zenith dependence
+                    CASE ( 1, 2, 3, 4, 11, 12, 13 )
+                       surf%rrtm_aldir(m) = surf%aldif(m) * 1.4_wp /                       &
+                                        (1.0_wp + 0.8_wp * zenith(0))
+                       surf%rrtm_asdir(m) = surf%asdif(m) * 1.4_wp /                       &
+                                        (1.0_wp + 0.8_wp * zenith(0))
+!
+!--                 Surface types with weak zenith dependence
+                    CASE ( 5, 6, 7, 8, 9, 10, 14 )
+                       surf%rrtm_aldir(m) = surf%aldif(m) * 1.1_wp /                       &
+                                        (1.0_wp + 0.2_wp * zenith(0))
+                       surf%rrtm_asdir(m) = surf%asdif(m) * 1.1_wp /                       &
+                                        (1.0_wp + 0.2_wp * zenith(0))
+
+                    CASE DEFAULT
+
+                 END SELECT
               ENDIF
 !
-!--        Sea ice
-           ELSEIF ( albedo_type == 15 )  THEN
-                 rrtm_aldir(0,:,:) = aldif
-                 rrtm_asdir(0,:,:) = asdif
-
-!
-!--        Bare soil
-           ELSEIF ( albedo_type == 17 )  THEN
-                 rrtm_aldir(0,:,:) = aldif
-                 rrtm_asdir(0,:,:) = asdif
-
-!
-!--        For impermeable surfaces, use values from the lookup table
-           ELSEIF ( albedo_type > 17 )  THEN
-                 rrtm_aldir(0,:,:) = aldif
-                 rrtm_asdir(0,:,:) = asdif
-!
-!--        Land surfaces
-           ELSE
-               SELECT CASE ( albedo_type )
-
-!
-!--              Surface types with strong zenith dependence
-                 CASE ( 1, 2, 3, 4, 11, 12, 13 )
-                    rrtm_aldir(0,:,:) = aldif * 1.4_wp /                       &
-                                        (1.0_wp + 0.8_wp * zenith(0))
-                    rrtm_asdir(0,:,:) = asdif * 1.4_wp /                       &
-                                        (1.0_wp + 0.8_wp * zenith(0))
-!
-!--              Surface types with weak zenith dependence
-                 CASE ( 5, 6, 7, 8, 9, 10, 14 )
-                    rrtm_aldir(0,:,:) = aldif * 1.1_wp /                       &
-                                        (1.0_wp + 0.2_wp * zenith(0))
-                    rrtm_asdir(0,:,:) = asdif * 1.1_wp /                       &
-                                        (1.0_wp + 0.2_wp * zenith(0))
-
-                 CASE DEFAULT
-
-              END SELECT
-           ENDIF
-!
-!--        Diffusive albedo is taken from Table 2
-           rrtm_aldif(0,:,:) = aldif
-           rrtm_asdif(0,:,:) = asdif
-
+!--           Diffusive albedo is taken from Table 2
+              surf%rrtm_aldif(m) = surf%aldif(m)
+              surf%rrtm_asdif(m) = surf%asdif(m)
+           ENDDO
+!
+!--     Set albedo in case of average radiation
+        ELSEIF ( sun_up  .AND.  average_radiation )  THEN
+           surf%rrtm_asdir = albedo_urb
+           surf%rrtm_asdif = albedo_urb
+           surf%rrtm_aldir = albedo_urb
+           surf%rrtm_aldif = albedo_urb  
+!
+!--     Darkness
         ELSE
-
-           rrtm_aldir(0,:,:) = 0.0_wp
-           rrtm_asdir(0,:,:) = 0.0_wp
-           rrtm_aldif(0,:,:) = 0.0_wp
-           rrtm_asdif(0,:,:) = 0.0_wp
+           surf%rrtm_aldir = 0.0_wp
+           surf%rrtm_asdir = 0.0_wp
+           surf%rrtm_aldif = 0.0_wp
+           surf%rrtm_asdif = 0.0_wp
         ENDIF
+
     END SUBROUTINE calc_albedo
 
Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2696)
@@ -2501,4 +6996,5 @@
     INTEGER(iwp) ::  j !< 
     INTEGER(iwp) ::  k !< 
+    INTEGER(iwp) ::  m !< index of current surface element 
 
     IF ( mode == 'allocate' )  THEN
@@ -2570,7 +7066,16 @@
 
           CASE ( 'rad_net*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   rad_net_av(j,i) = rad_net_av(j,i) + rad_net(j,i)
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO m = surf_def_h(0)%start_index(j,i),                      &
+                          surf_def_h(0)%end_index(j,i)
+                      rad_net_av(j,i) = rad_net_av(j,i) + surf_def_h(0)%rad_net(m)
+                   ENDDO
+                   DO m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
+                      rad_net_av(j,i) = rad_net_av(j,i) + surf_lsm_h%rad_net(m)
+                   ENDDO
+                   DO m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
+                      rad_net_av(j,i) = rad_net_av(j,i) + surf_usm_h%rad_net(m)
+                   ENDDO
                 ENDDO
              ENDDO
@@ -2835,4 +7340,5 @@
     INTEGER(iwp) ::  j  !< 
     INTEGER(iwp) ::  k  !< 
+    INTEGER(iwp) ::  m  !< index of surface element at grid point (j,i)
 
     LOGICAL      ::  found !< 
@@ -2849,5 +7355,23 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   local_pf(i,j,nzb+1) = rad_net(j,i)
+!
+!--                Obtain rad_net from its respective surface type
+!--                Default-type surfaces
+                   DO  m = surf_def_h(0)%start_index(j,i),                     &
+                           surf_def_h(0)%end_index(j,i) 
+                      local_pf(i,j,nzb+1) = surf_def_h(0)%rad_net(m)
+                   ENDDO
+!
+!--                Natural-type surfaces
+                   DO  m = surf_lsm_h%start_index(j,i),                        &
+                           surf_lsm_h%end_index(j,i)  
+                      local_pf(i,j,nzb+1) = surf_lsm_h%rad_net(m)
+                   ENDDO
+!
+!--                Urban-type surfaces
+                   DO  m = surf_usm_h%start_index(j,i),                        &
+                           surf_usm_h%end_index(j,i)  
+                      local_pf(i,j,nzb+1) = surf_usm_h%rad_net(m)
+                   ENDDO
                 ENDDO
              ENDDO
@@ -3454,7 +7978,4 @@
 
     IF ( write_binary )  THEN
-       IF ( ALLOCATED( rad_net ) )  THEN
-          WRITE ( 14 )  'rad_net             ';  WRITE ( 14 )  rad_net  
-       ENDIF
        IF ( ALLOCATED( rad_net_av ) )  THEN
           WRITE ( 14 )  'rad_net_av          ';  WRITE ( 14 )  rad_net_av  
@@ -3472,8 +7993,4 @@
           WRITE ( 14 )  'rad_lw_out_av       ';  WRITE ( 14 )  rad_lw_out_av  
        ENDIF 
-       IF ( ALLOCATED( rad_lw_out_change_0 ) )  THEN
-          WRITE ( 14 )  'rad_lw_out_change_0 '
-          WRITE ( 14 )  rad_lw_out_change_0
-       ENDIF
        IF ( ALLOCATED( rad_lw_cs_hr ) )  THEN
           WRITE ( 14 )  'rad_lw_cs_hr        ';  WRITE ( 14 )  rad_lw_cs_hr
@@ -3594,12 +8111,4 @@
             SELECT CASE ( TRIM( field_char ) )
 
-                CASE ( 'rad_net' )
-                   IF ( .NOT. ALLOCATED( rad_net ) )  THEN
-                      ALLOCATE( rad_net(nysg:nyng,nxlg:nxrg) )
-                   ENDIF  
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   rad_net(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  =         &
-                                 tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'rad_net_av' )
                    IF ( .NOT. ALLOCATED( rad_net_av ) )  THEN
@@ -3697,12 +8206,4 @@
                    ENDIF
 
-                CASE ( 'rad_lw_out_change_0' )
-                   IF ( .NOT. ALLOCATED( rad_lw_out_change_0 ) )  THEN
-                      ALLOCATE( rad_lw_out_change_0(nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   rad_lw_out_change_0(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)&
-                              = tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'rad_lw_cs_hr' )
                    IF ( .NOT. ALLOCATED( rad_lw_cs_hr ) )  THEN
Index: palm/trunk/SOURCE/random_function_mod.f90
===================================================================
--- palm/trunk/SOURCE/random_function_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/random_function_mod.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file random_function_mod.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/random_gauss.f90
===================================================================
--- palm/trunk/SOURCE/random_gauss.f90	(revision 2693)
+++ palm/trunk/SOURCE/random_gauss.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file random_gauss.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/random_generator_parallel_mod.f90
===================================================================
--- palm/trunk/SOURCE/random_generator_parallel_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/random_generator_parallel_mod.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file random_generator_parallel_mod.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Formatting (MS)
+! 
+! 2255 2017-06-07 11:58:09Z knoop
 ! Implemented PALM specific error message handling
 ! 
@@ -158,22 +161,22 @@
       id_random_array  = 0
 
-!--       Asigning an ID to every vertical gridpoint column 
-!--       dependig on the ensemble run number.
-          DO i=nxl, nxr
-             DO j=nys, nyn
-                id_random_array(j,i) = j*(nx+1.0_wp) + i + 1.0_wp + 1E6 * &
-                                       ( ensemble_member_nr - 1000 )
-             ENDDO
-          ENDDO
-!--       Initializing with random_seed_parallel for every vertical 
-!--       gridpoint column.
-          random_dummy=0
-          DO i = nxl, nxr
-             DO j = nys, nyn
-                CALL random_seed_parallel (random_sequence=id_random_array(j, i))
-                CALL random_number_parallel (random_dummy)
-                CALL random_seed_parallel (get=seq_random_array(:, j, i))
-             ENDDO
-          ENDDO
+!--   Asigning an ID to every vertical gridpoint column 
+!--   dependig on the ensemble run number.
+      DO i=nxl, nxr
+         DO j=nys, nyn
+            id_random_array(j,i) = j*(nx+1.0_wp) + i + 1.0_wp + 1E6 * &
+                                   ( ensemble_member_nr - 1000 )
+         ENDDO
+      ENDDO
+!--   Initializing with random_seed_parallel for every vertical 
+!--   gridpoint column.
+      random_dummy=0
+      DO i = nxl, nxr
+         DO j = nys, nyn
+            CALL random_seed_parallel (random_sequence=id_random_array(j, i))
+            CALL random_number_parallel (random_dummy)
+            CALL random_seed_parallel (get=seq_random_array(:, j, i))
+         ENDDO
+      ENDDO
 
    END SUBROUTINE init_parallel_random_generator
Index: palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/read_3d_binary.f90	(revision 2693)
+++ palm/trunk/SOURCE/read_3d_binary.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file read_3d_binary.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -21,8 +21,13 @@
 ! -----------------
 ! 
-!
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! - kh_av, km_av (TG)
+! - Implementation of chemistry module (FK)
+! - Changes from trunk concerning random generator added (MS)
+! 
+! 2644 2017-11-27 09:27:09Z raasch
 ! further bugfix for r2636 (wrong datatype used for allocation)
 !
@@ -144,7 +149,12 @@
     USE averaging
 
+#if defined( __chem )
+    USE chemistry_model_mod,                                                   &
+        ONLY:  chem_read_restart_data, chem_species, nspec                                
+#endif
+
     USE control_parameters,                                                    &
-        ONLY:  iran, land_surface, message_string, outflow_l, outflow_n,       &
-               outflow_r, outflow_s, urban_surface
+        ONLY:  air_chemistry, iran, land_surface, message_string, outflow_l,   &
+               outflow_n, outflow_r, outflow_s, urban_surface
 
     USE cpulog,                                                                &
@@ -234,5 +244,5 @@
     REAL(wp) ::  rdummy
 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE     ::  tmp_2d      !< temporary array for storing 2D data
+    REAL(wp), DIMENSION(:,:),   ALLOCATABLE   ::  tmp_2d      !< temporary array for storing 2D data
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3d      !< temporary array for storing 3D data
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwul   !<
@@ -360,5 +370,5 @@
 !--    First compare the version numbers
        READ ( 13 )  version_on_file
-       binary_version = '4.5'
+       binary_version = '4.6'
        IF ( TRIM( version_on_file ) /= TRIM( binary_version ) )  THEN
           WRITE( message_string, * ) 'version mismatch concerning data ',      &
@@ -460,7 +470,4 @@
              nync = nynfa(i,k) + offset_ya(i,k)
 
-             write(9,*) "f", nxlf, nxrf, nysf, nynf
-             write(9,*) "c", nxlc, nxrc, nysc, nync
-
 
 
@@ -489,8 +496,24 @@
                              tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
+                CASE ( 'kh_av' )
+                   IF ( .NOT. ALLOCATED( kh_av ) )  THEN
+                      ALLOCATE( kh_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg ))
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   kh_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
                 CASE ( 'km' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
                    km(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
                                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'km_av' )
+                   IF ( .NOT. ALLOCATED( km_av ) )  THEN
+                      ALLOCATE( km_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg ))
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   km_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'lpt_av' )
@@ -703,5 +726,5 @@
                    IF ( k == 1 )  READ ( 13 )  random_iv
                    IF ( k == 1 )  READ ( 13 )  random_iy
-                   
+
                 CASE ( 'seq_random_array' )
                    ALLOCATE( tmp_2d_id_random(nys_on_file:nyn_on_file,         &
@@ -722,4 +745,5 @@
                                        tmp_2d_seq_random(:,nysf:nynf,nxlf:nxrf)
                    DEALLOCATE( tmp_2d_id_random, tmp_2d_seq_random )
+
                 CASE ( 'rho_ocean_av' )
                    IF ( .NOT. ALLOCATED( rho_ocean_av ) )  THEN
@@ -1054,4 +1078,13 @@
 
 !
+!--    Read urban surface restart data
+       IF ( urban_surface )  THEN
+          CALL usm_read_restart_data( i, nxlfa, nxl_on_file, nxrfa,            &
+                                      nxr_on_file, nynfa, nyn_on_file, nysfa,  &
+                                      nys_on_file, offset_xa, offset_ya,       &
+                                      overlap_count(i) )
+       ENDIF
+
+!
 !--    Read land surface restart data
        IF ( land_surface )  THEN
@@ -1061,13 +1094,4 @@
                                       overlap_count(i), tmp_2d )
 
-       ENDIF
-       
-!
-!--    Read land surface restart data
-       IF ( urban_surface )  THEN
-          CALL usm_read_restart_data( i, nxlfa, nxl_on_file, nxrfa,            &
-                                      nxr_on_file, nynfa, nyn_on_file, nysfa,  &
-                                      nys_on_file, offset_xa, offset_ya,       &
-                                      overlap_count(i) )
        ENDIF
 
@@ -1083,4 +1107,16 @@
 
 !
+!--    Read chemistry restart data
+#if defined( __chem )
+       IF ( air_chemistry )  THEN
+          CALL chem_read_restart_data( i, nxlfa, nxl_on_file, nxrfa,           &
+                                       nxr_on_file, nynfa, nyn_on_file,        &
+                                       nysfa, nys_on_file, offset_xa,          &
+                                       offset_ya, overlap_count(i),            &
+                                       tmp_2d, tmp_3d )
+       ENDIF
+#endif
+
+!
 !--    Read user-defined restart data
        CALL user_read_restart_data( i, nxlfa, nxl_on_file, nxrfa, nxr_on_file, &
Index: palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- palm/trunk/SOURCE/read_var_list.f90	(revision 2693)
+++ palm/trunk/SOURCE/read_var_list.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file read_var_list.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! + rans_mode, turbulence_closure (TG)
+! 
+! 2576 2017-10-24 13:49:46Z Giersch
 ! *** end *** marks the end of the standard parameter list of restart files
 ! like it was before revision 2563. To skip also the variables of the modules  
@@ -283,5 +286,5 @@
 !-- Make version number check first
     READ ( 13 )  version_on_file
-    binary_version = '4.4'
+    binary_version = '4.5'
     IF ( TRIM( version_on_file ) /= TRIM( binary_version ) )  THEN
        WRITE( message_string, * ) 'version mismatch concerning control ', &
@@ -636,4 +639,6 @@
           CASE ( 'random_heatflux' )
              READ ( 13 )  random_heatflux
+          CASE ( 'rans_mode' )
+             READ ( 13 )  rans_mode
           CASE ( 'rayleigh_damping_factor' )
              READ ( 13 )  rayleigh_damping_factor
@@ -758,4 +763,6 @@
           CASE ( 'tunnel_wall_depth' )
              READ ( 13 )  tunnel_wall_depth
+          CASE ( 'turbulence_closure' )
+             READ ( 13 )  turbulence_closure
           CASE ( 'turbulent_inflow' )
              READ ( 13 )  turbulent_inflow
Index: palm/trunk/SOURCE/run_control.f90
===================================================================
--- palm/trunk/SOURCE/run_control.f90	(revision 2693)
+++ palm/trunk/SOURCE/run_control.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file run_control.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/set_slicer_attributes_dvrp.f90
===================================================================
--- palm/trunk/SOURCE/set_slicer_attributes_dvrp.f90	(revision 2693)
+++ palm/trunk/SOURCE/set_slicer_attributes_dvrp.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file set_slicer_attributes_dvrp.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/sor.f90
===================================================================
--- palm/trunk/SOURCE/sor.f90	(revision 2693)
+++ palm/trunk/SOURCE/sor.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file sor.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! - Large-scale forcing implemented (MS)
+! 
+! 2101 2017-01-05 16:42:31Z suehring
 !
 ! 2037 2016-10-26 11:15:40Z knoop
@@ -75,8 +78,9 @@
 
     USE control_parameters,                                                    &
-        ONLY:  bc_lr_cyc, bc_ns_cyc, ibc_p_b, ibc_p_t, inflow_l, inflow_n,     &
-               inflow_r, inflow_s, nest_bound_l, nest_bound_n, nest_bound_r,   &
-               nest_bound_s, n_sor, omega_sor, outflow_l, outflow_n,           &
-               outflow_r, outflow_s
+        ONLY:  bc_lr_cyc, bc_ns_cyc, force_bound_l, force_bound_n,             &
+               force_bound_r, force_bound_s, ibc_p_b, ibc_p_t, inflow_l,       &
+               inflow_n, inflow_r, inflow_s, nest_bound_l, nest_bound_n,       &
+               nest_bound_r, nest_bound_s, n_sor, omega_sor, outflow_l,        &
+               outflow_n, outflow_r, outflow_s
 
     IMPLICIT NONE
@@ -167,10 +171,14 @@
 !--    Horizontal (Neumann) boundary conditions in case of non-cyclic boundaries
        IF ( .NOT. bc_lr_cyc )  THEN
-          IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  p(:,:,nxl-1) = p(:,:,nxl)
-          IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  p(:,:,nxr+1) = p(:,:,nxr)
+          IF ( inflow_l      .OR.  outflow_l  .OR.                                 &
+               nest_bound_l  .OR.  force_bound_l )  p(:,:,nxl-1) = p(:,:,nxl)
+          IF ( inflow_r      .OR.  outflow_r  .OR.                                 &
+               nest_bound_r  .OR.  force_bound_r )  p(:,:,nxr+1) = p(:,:,nxr)
        ENDIF
        IF ( .NOT. bc_ns_cyc )  THEN
-          IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  p(:,nyn+1,:) = p(:,nyn,:)
-          IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  p(:,nys-1,:) = p(:,nys,:)
+          IF ( inflow_n      .OR.  outflow_n  .OR.                                 &
+               nest_bound_n  .OR.  force_bound_n )  p(:,nyn+1,:) = p(:,nyn,:)
+          IF ( inflow_s      .OR.  outflow_s  .OR.                                 &
+               nest_bound_s  .OR.  force_bound_s )  p(:,nys-1,:) = p(:,nys,:)
        ENDIF
 
@@ -229,10 +237,14 @@
 !--    Horizontal (Neumann) boundary conditions in case of non-cyclic boundaries
        IF ( .NOT. bc_lr_cyc )  THEN
-          IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  p(:,:,nxl-1) = p(:,:,nxl)
-          IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  p(:,:,nxr+1) = p(:,:,nxr)
+          IF ( inflow_l      .OR.  outflow_l  .OR.                             &
+               nest_bound_l  .OR.  force_bound_l )  p(:,:,nxl-1) = p(:,:,nxl)
+          IF ( inflow_r      .OR.  outflow_r  .OR.                             &
+               nest_bound_r  .OR.  force_bound_r )  p(:,:,nxr+1) = p(:,:,nxr)
        ENDIF
        IF ( .NOT. bc_ns_cyc )  THEN
-          IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  p(:,nyn+1,:) = p(:,nyn,:)
-          IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  p(:,nys-1,:) = p(:,nys,:)
+          IF ( inflow_n      .OR.  outflow_n  .OR.                             &
+               nest_bound_n  .OR.  force_bound_n )  p(:,nyn+1,:) = p(:,nyn,:)
+          IF ( inflow_s      .OR.  outflow_s  .OR.                             &
+               nest_bound_s  .OR.  force_bound_s )  p(:,nys-1,:) = p(:,nys,:)
        ENDIF
 
Index: palm/trunk/SOURCE/spectra_mod.f90
===================================================================
--- palm/trunk/SOURCE/spectra_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/spectra_mod.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file spectra_mod.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/subsidence_mod.f90
===================================================================
--- palm/trunk/SOURCE/subsidence_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/subsidence_mod.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file subsidence_mod.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
